"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _reactCodemirror = _interopRequireDefault(require("@uiw/react-codemirror"));

var _copyToClipboard = _interopRequireDefault(require("@uiw/copy-to-clipboard"));

var _langJavascript = require("@codemirror/lang-javascript");

var _reactSplit = _interopRequireDefault(require("@uiw/react-split"));

var _ThirdPartyButton = _interopRequireDefault(require("./ThirdPartyButton"));

var icon = _interopRequireWildcard(require("./icon"));

var _ErrorMessage = require("./ErrorMessage");

var _useCodePreview2 = require("./useCodePreview");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["style", "prefixCls", "className", "theme", "editProps", "codePenOption", "codeSandboxOption", "code", "dependencies", "btnText", "btnHideText", "onlyEdit", "bordered", "noCode", "noPreview", "noScroll", "bgWhite"];

var CodePreview = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var style = props.style,
      _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? 'w-code-preview' : _props$prefixCls,
      className = props.className,
      _props$theme = props.theme,
      theme = _props$theme === void 0 ? 'light' : _props$theme,
      _props$editProps = props.editProps,
      editProps = _props$editProps === void 0 ? {} : _props$editProps,
      codePenOption = props.codePenOption,
      codeSandboxOption = props.codeSandboxOption,
      _props$code = props.code,
      _Code = _props$code === void 0 ? '' : _props$code,
      _props$dependencies = props.dependencies,
      dependencies = _props$dependencies === void 0 ? {} : _props$dependencies,
      _props$btnText = props.btnText,
      btnText = _props$btnText === void 0 ? 'Code' : _props$btnText,
      _props$btnHideText = props.btnHideText,
      btnHideText = _props$btnHideText === void 0 ? 'Hide Editor' : _props$btnHideText,
      _props$onlyEdit = props.onlyEdit,
      onlyEdit = _props$onlyEdit === void 0 ? false : _props$onlyEdit,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? true : _props$bordered,
      _props$noCode = props.noCode,
      noCode = _props$noCode === void 0 ? false : _props$noCode,
      _props$noPreview = props.noPreview,
      noPreview = _props$noPreview === void 0 ? false : _props$noPreview,
      _props$noScroll = props.noScroll,
      noScroll = _props$noScroll === void 0 ? false : _props$noScroll,
      _props$bgWhite = props.bgWhite,
      bgWhite = _props$bgWhite === void 0 ? false : _props$bgWhite,
      otherProps = (0, _objectWithoutProperties2.default)(props, _excluded);

  var _useCodePreview = (0, _useCodePreview2.useCodePreview)((0, _objectSpread2.default)({
    code: _Code,
    dependencies: dependencies
  }, props)),
      playerId = _useCodePreview.playerId,
      setDemoDom = _useCodePreview.setDemoDom,
      code = _useCodePreview.code,
      setCode = _useCodePreview.setCode,
      fullScreen = _useCodePreview.fullScreen,
      setFullScreen = _useCodePreview.setFullScreen,
      errorMessage = _useCodePreview.errorMessage,
      width = _useCodePreview.width,
      setWidth = _useCodePreview.setWidth,
      showEdit = _useCodePreview.showEdit,
      setShowEdit = _useCodePreview.setShowEdit,
      copied = _useCodePreview.copied,
      setCopied = _useCodePreview.setCopied;

  var demoRef = (0, _react.useRef)(null);
  var editor = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      editor: editor,
      demo: demoRef.current
    };
  }, [editor, demoRef]);
  var isOneItem = !noCode && !noPreview ? false : !noCode || !noPreview;
  var visiable = width === 1 ? false : [isOneItem ? 1 : 2];
  var cls = [className, prefixCls, noScroll ? "".concat(prefixCls, "-noScroll") : null, isOneItem ? "".concat(prefixCls, "-OneItem") : null, bordered ? "".concat(prefixCls, "-bordered") : null, fullScreen ? "".concat(prefixCls, "-fullScreen") : null].filter(Boolean).join(' ').trim(); // eslint-disable-next-line react-hooks/exhaustive-deps

  (0, _react.useEffect)(function () {
    return setCode(_Code);
  }, [_Code]);
  (0, _react.useEffect)(function () {
    if (demoRef.current) {
      setDemoDom(demoRef.current);
    }

    window.addEventListener('popstate', function (e) {
      document.body.style.overflow = 'inherit';
    }, false); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);

  var transitionend = function transitionend() {
    return setShowEdit(width !== 1);
  };

  (0, _react.useEffect)(function () {
    var dom = demoRef.current;

    if (dom) {
      dom.addEventListener('transitionend', transitionend);
    }

    return function () {
      if (dom) {
        dom.removeEventListener('transitionend', transitionend);
      }
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [width]);

  var handleChange = function handleChange(value, viewUpdate) {
    setCode(value);

    if (editProps && editProps.onChange) {
      editProps.onChange(value, viewUpdate);
    }
  };

  var onSwitchSource = function onSwitchSource() {
    setWidth(width === 1 ? '50%' : 1);
    setShowEdit(true);
  };

  var onCopyCode = function onCopyCode() {
    (0, _copyToClipboard.default)(code || '', function (isCopy) {
      return setCopied(isCopy);
    });
    setTimeout(function () {
      return setCopied(false);
    }, 2000);
  };

  var onFullScreen = function onFullScreen() {
    setFullScreen(!fullScreen);
    document.body.style.overflow = !fullScreen ? 'hidden' : 'inherit';

    if (!fullScreen && demoRef.current) {
      demoRef.current.style.maxWidth = 'inherit';
    }
  };

  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_reactSplit.default, (0, _objectSpread2.default)((0, _objectSpread2.default)({
    visiable: visiable,
    className: cls,
    style: (0, _objectSpread2.default)({
      flex: 1
    }, style)
  }, otherProps), {}, {
    children: [!noPreview && !onlyEdit && /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: ["".concat(prefixCls, "-demo"), !bgWhite ? "".concat(prefixCls, "-demo-bgPlaid") : null, errorMessage ? "".concat(prefixCls, "-demo-error") : null].filter(Boolean).join(' ').trim(),
      style: (0, _objectSpread2.default)({
        flex: 1
      }, width === 1 ? {
        width: '100%'
      } : {}),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_ErrorMessage.ErrorMessage, {
        message: errorMessage
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ["".concat(prefixCls, "-demo-source"), errorMessage ? 'error' : null].filter(Boolean).join(' ').trim(),
        id: playerId.current
      })]
    }), (!noCode || onlyEdit) && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      ref: demoRef,
      style: {
        overflow: 'hidden',
        width: onlyEdit ? '100%' : width
      },
      children: (showEdit || onlyEdit) && /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactCodemirror.default, (0, _objectSpread2.default)((0, _objectSpread2.default)({
        value: (code || '').replace(/\n$/, ''),
        ref: editor,
        theme: theme,
        extensions: [(0, _langJavascript.javascript)({
          jsx: true
        })]
      }, editProps), {}, {
        style: {
          height: '100%'
        },
        height: "100%",
        onChange: handleChange
      }))
    }), !isOneItem && !(noCode && noPreview) && !onlyEdit && /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      style: {
        flex: 1,
        width: 29
      },
      className: "".concat(prefixCls, "-bar"),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_ThirdPartyButton.default, {
        prefixCls: prefixCls,
        codePenOption: codePenOption,
        codeSandboxOption: codeSandboxOption
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: "".concat(prefixCls, "-bar-btn"),
        onClick: onSwitchSource,
        children: width === 1 ? btnText : btnHideText
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ["".concat(prefixCls, "-bar-iconbtns"), copied ? "".concat(prefixCls, "-bar-copied") : null].filter(Boolean).join(' ').trim(),
        onClick: onCopyCode,
        children: copied ? icon.copyOk : icon.copy
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ["".concat(prefixCls, "-bar-iconbtns"), fullScreen ? "".concat(prefixCls, "-bar-copied") : null].filter(Boolean).join(' ').trim(),
        onClick: onFullScreen,
        children: icon.full
      })]
    })]
  }));
});

CodePreview.displayName = 'CodePreview';
var _default = CodePreview;
exports.default = _default;
module.exports = exports.default;
//# sourceMappingURL=index.js.map