"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useCodePreview = useCodePreview;

var _construct2 = _interopRequireDefault(require("@babel/runtime/helpers/construct"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _client = _interopRequireDefault(require("react-dom/client"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _transform = require("./transform");

var _excluded = ["React", "ReactDOM", "ReactDOMClient"];

function useCodePreview(props) {
  var _useState = (0, _react.useState)(),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      demoDom = _useState2[0],
      setDemoDom = _useState2[1];

  var playerId = (0, _react.useRef)("".concat(parseInt(String(Math.random() * 1e9), 10).toString(36)));

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      fullScreen = _useState4[0],
      setFullScreen = _useState4[1];

  var _useState5 = (0, _react.useState)(''),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      errorMessage = _useState6[0],
      setErrorMessage = _useState6[1];

  var _useState7 = (0, _react.useState)(false),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      showEdit = _useState8[0],
      setShowEdit = _useState8[1];

  var _useState9 = (0, _react.useState)(1),
      _useState10 = (0, _slicedToArray2.default)(_useState9, 2),
      width = _useState10[0],
      setWidth = _useState10[1];

  var _useState11 = (0, _react.useState)(false),
      _useState12 = (0, _slicedToArray2.default)(_useState11, 2),
      copied = _useState12[0],
      setCopied = _useState12[1];

  var _useState13 = (0, _react.useState)(props.code || ''),
      _useState14 = (0, _slicedToArray2.default)(_useState13, 2),
      code = _useState14[0],
      setCode = _useState14[1];
  /** 通过缓存的方式 解决 react v18 中 的报错   ***/
  // @ts-ignore


  var cachesRef = _react.default.useRef(new Map([]));

  var ReactDOMRender = function ReactDOMRender(_ReactDOM) {
    return {
      createRoot: function createRoot(id) {
        return {
          render: function render(_render) {
            var caches = cachesRef.current;
            var root = caches.get(id); // 存在则不需要重新创建直接进行render操作

            if (root) {
              root.render(_render);
            } else {
              // @ts-ignore
              root = _ReactDOM.createRoot(document.getElementById(id));
              root.render(_render); // 缓存，解决控制台报  ReactDOMClient.createRoot 问题

              caches.set(id, root);
            }

            cachesRef.current = caches;
          }
        };
      }
    };
  };
  /**  ------------------------   ***/


  var executeCode = function executeCode(str) {
    var _ref = props.dependencies || {},
        _React = _ref.React,
        _ReactDOM = _ref.ReactDOM,
        _ReactDOMClient = _ref.ReactDOMClient,
        otherDeps = (0, _objectWithoutProperties2.default)(_ref, _excluded);

    var V18ReactDOM = _ReactDOMClient || _client.default || _ReactDOM || _reactDom.default; // 判断是否是 react v18版本

    var isV18 = Reflect.has(V18ReactDOM || {}, 'createRoot');
    var NewReactDOM = isV18 ? ReactDOMRender(V18ReactDOM) : V18ReactDOM;

    try {
      var deps = (0, _objectSpread2.default)((0, _objectSpread2.default)({
        React: _React || _react.default
      }, otherDeps), {}, {
        ReactDOM: NewReactDOM
      }); // const args = ['context', 'React', 'ReactDOM', 'Component'];

      var args = []; // const argv = [this, React, ReactDOM, Component];

      var argv = [];

      for (var key in deps) {
        args.push(key);
        argv.push(deps[key]);
      }

      if (isV18) {
        // react < v18 中写法替换
        str = str.replace('ReactDOM.render', "ReactDOM.createRoot(\"".concat(playerId.current, "\").render")); // react v18 中写法替换

        str = str.replace("ReactDOMClient.createRoot(_mount_)", "ReactDOM.createRoot(\"".concat(playerId.current, "\")"));
        str = str.replace('_mount_', "");
      } else {
        str = str.replace('_mount_', "document.getElementById('".concat(playerId.current, "')"));
      }

      var input = "".concat(str);

      var _babelTransform = (0, _transform.babelTransform)(input),
          _code = _babelTransform.code;

      args.push(_code || ''); // console.log('code:', argv)
      // eslint-disable-next-line no-new-func

      (0, _construct2.default)(Function, args).apply(null, argv);
      setErrorMessage('');
    } catch (err) {
      var message = '';

      if (err && err.message) {
        message = err.message;
      } else {
        message = JSON.stringify(err);
      }

      setErrorMessage(message);
    }
  }; // eslint-disable-next-line react-hooks/exhaustive-deps


  (0, _react.useEffect)(function () {
    return executeCode(code);
  }, [code, props.noPreview, demoDom]);
  return {
    playerId: playerId,
    demoDom: demoDom,
    setDemoDom: setDemoDom,
    fullScreen: fullScreen,
    setFullScreen: setFullScreen,
    errorMessage: errorMessage,
    setErrorMessage: setErrorMessage,
    width: width,
    setWidth: setWidth,
    showEdit: showEdit,
    setShowEdit: setShowEdit,
    copied: copied,
    setCopied: setCopied,
    code: code,
    setCode: setCode,
    executeCode: executeCode
  };
}
//# sourceMappingURL=useCodePreview.js.map